
$GhostAllBricks::bricksPerTick = 250;


%n = GhostAllBricks;

if(!isObject(%n))
{
	%n = new SimSet(GhostAllBricks);
	for(%groupNum = 0; %groupNum < MainBrickGroup.getCount(); %groupNum++)
	{
		%group = MainBrickGroup.getObject(%groupNum);
		for(%brickNum = 0; %brickNum < %group.getCount(); %brickNum++)
			%n.add(%group.getObject(%brickNum));
	}
}

if(!isObject(GhostAllGhosters))
	%n = new SimSet(GhostAllGhosters);


function GameConnection::ghostAllBricks(%this, %index)
{
	cancel(%this.ghostSched);

	if(!GhostAllGhosters.isMember(%this))
		return;

	//Decrease the index by the regression count.

	//This is to prevent a situation where bricks inside the last index range were
	//deleted, thus causing the ghostAllBricks to skip up to an entire index range.

	%index -= %this.regressionCount;
	%this.regressionCount = 0;

	if(%index <= 0 || %index $= "")
		%index = 0;



	%group = GhostAllBricks;
	%count = %group.getCount();
 
	for(%i = 0; %i < $GhostAllBricks::bricksPerTick; %i++)
	{

		if(%index >= %count)
			break;

		%this.scopeCount += 1;
		%group.getObject(%index).scopeToClient(%this);

		%index++;
	}
 
	if(%index >= %count)
	{
		%printString = "\c6Loading Bricks - \c2100% \c6("@ %count @" bricks)";
		commandToClient(%this, 'bottomPrint', %printString, 2);

		GhostAllGhosters.remove(%this);

		return;
	}
 
	%progress = mFloor((%index / %count) * 100);
 
	commandToClient(%this, 'bottomPrint', "\c6Loading Bricks - \c3" @ %progress @ "%", 2);

	%this.ghostSched = %this.schedule(32, "ghostAllBricks", %index);
}

deactivatePackage(GhostToAll);

package GhostToAll
{
	function GameConnection::activateGhosting(%this)
	{
		Parent::activateGhosting(%this);

		GhostAllGhosters.add(%this);

		cancel(%this.ghostSched);
		%this.ghostSched = %this.schedule(1000, ghostAllbricks, 0);
	}


	function fxDTSBrick::onAdd(%this)
	{
		%group = ClientGroup;

		//From New Duplicator, not quite sure what the clear scope will improve
		for(%i = 0; %i < %group.getCount(); %i++)
		{
			%this.scopeToClient(%group.getObject(%i));
			%this.clearScopeToClient(%group.getObject(%i));
		}

		GhostAllBricks.add(%this);

		return Parent::onAdd(%this);
	}

	function fxDTSBrick::onRemove(%this)
	{
		//set the counter up one so as to hold back list traversal
		%g = GhostAllGhosters;

		for(%i = 0; %i < %g.getCount(); %i++)
			%g.getObject(%i).regressionCount += 1;

		return Parent::onRemove(%this);
	}
};

activatePackage(GhostToAll);